---
title: "Full Row Editing"
framework: react
version: "36.1.0"
---

# Full Row Editing

Full row editing is for when you want all cells in the row to become editable at the same time. This gives the impression to the user that the record the row represents is being edited.

To enable full row editing, set the grid option `editType = 'fullRow'`.

If using custom cell editors, the cell editors will work in the exact same way with the following additions:

- `focusIn`: If your cell editor has a `focusIn()` method, it will get called when the user tabs into the cell. This should be used to put the focus on the particular item to be focused, e.g. the `textfield` within your cell editor.
- `focusOut`: If your cell editor has a `focusOut()` method, it will get called when the user tabs out of the cell. There is no intended use for this; it's just there to complement the `focusIn()` method.
- Events: When a row stops editing, the `cellValueChanged` event gets called for each column whose value has changed, and `rowValueChanged` gets called once for the row.

### Full Row Edit and Popup Editors

Full row editing is not compatible with popup editors. This is because a) the grid would look confusing to pop up an editor for each cell in the row at the same time and b) the complexity of navigation and popup is almost impossible to model, so the grid and your application code would be messy and very error prone. If you are using full row edit, then you are prevented from using popup editors.

This does not mean that you cannot show a popup from your 'in cell' editor - you are free to do that - however the responsibility of showing and hiding the popup belongs with your editor. You may want to use the grid's focus events to hide the popups when the user tabs or clicks out of the cell.

### Example: Full Row Edit

The example below shows full row editing. In addition to standard full row editing, the following should also be noted:

- The 'Price' column has a custom editor demonstrating how you should implement the `focusIn()` method. Both `focusIn()` and `focusOut()` for this editor are logged to the console. Note that `focusIn()` and `focusOut()` are only called when the user is tabbing between cells when editing, they are not called as the user double clicks on a cell to start editing that cell, or the user finishes editing that cell by e.g. hitting the `↵ Enter` key.
- Pressing `⇥ Tab` / `⇧ Shift` & `⇥ Tab` while editing will move the focus between the cells on the editing row. Read only cells will be focusable while the row is in edit mode.
- The 'Suppress Navigable' column is not navigable using `⇥ Tab` / `⇧ Shift` & `⇥ Tab`. In other words, when tabbing around the grid, you cannot tab onto this cell.
- The **Read Only** column is not editable, so when the row goes into edit mode, the cell in the **Read Only** column cannot be edited.
- The button will start editing line two. It uses the API to start editing a cell, however the result is that the whole row will become editable starting with the specified cell.
- `cellValueChanged` and `rowValueChanged` events are logged to console.

#### Full Row Editing

```tsx
'use client';
import React, {
  StrictMode,
  useCallback,
  useMemo,
  useRef,
  useState,
} from "react";
import { createRoot } from "react-dom/client";

import type {
  CellValueChangedEvent,
  ColDef,
  RowValueChangedEvent,
} from "ag-grid-community";
import {
  ClientSideRowModelModule,
  CustomEditorModule,
  SelectEditorModule,
  TextEditorModule,
  enableDevValidations,
} from "ag-grid-community";
import {
  ColumnMenuModule,
  ColumnsToolPanelModule,
  ContextMenuModule,
} from "ag-grid-enterprise";
import { AgGridProvider, AgGridReact } from "ag-grid-react";

import NumericCellEditor from "./numericCellEditor";
import "./styles.css";

// Enable extended validations only for development
if (process.env.NODE_ENV !== "production") {
  enableDevValidations();
}

const modules = [
  SelectEditorModule,
  ClientSideRowModelModule,
  ColumnsToolPanelModule,
  ColumnMenuModule,
  ContextMenuModule,
  CustomEditorModule,
  TextEditorModule,
];

function getRowData(): any[] {
  const rowData: any[] = [];
  for (let i = 0; i < 10; i++) {
    rowData.push({
      make: "Toyota",
      model: "Celica",
      price: 35000 + i * 1000,
      field4: "Sample XX",
      field5: "Sample 22",
      field6: "Sample 23",
    });
    rowData.push({
      make: "Ford",
      model: "Mondeo",
      price: 32000 + i * 1000,
      field4: "Sample YY",
      field5: "Sample 24",
      field6: "Sample 25",
    });
    rowData.push({
      make: "Porsche",
      model: "Boxster",
      price: 72000 + i * 1000,
      field4: "Sample ZZ",
      field5: "Sample 26",
      field6: "Sample 27",
    });
  }
  return rowData;
}

const GridExample = () => {
  const gridRef = useRef<AgGridReact>(null);
  const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
  const gridStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);
  const [rowData, setRowData] = useState<any[]>(getRowData());
  const [columnDefs, setColumnDefs] = useState<ColDef[]>([
    {
      field: "make",
      cellEditor: "agSelectCellEditor",
      cellEditorParams: {
        values: ["Porsche", "Toyota", "Ford", "AAA", "BBB", "CCC"],
      },
    },
    { field: "model" },
    { field: "field4", headerName: "Read Only", editable: false },
    { field: "price", cellEditor: NumericCellEditor },
    {
      headerName: "Suppress Navigable",
      field: "field5",
      suppressNavigable: true,
      minWidth: 200,
    },
    { headerName: "Read Only", field: "field6", editable: false },
  ]);
  const defaultColDef = useMemo<ColDef>(() => {
    return {
      flex: 1,
      editable: true,
      cellDataType: false,
    };
  }, []);

  const onCellValueChanged = useCallback((event: CellValueChangedEvent) => {
    console.log(
      "onCellValueChanged: " + event.colDef.field + " = " + event.newValue,
    );
  }, []);

  const onRowValueChanged = useCallback((event: RowValueChangedEvent) => {
    const data = event.data;
    console.log(
      "onRowValueChanged: (" +
        data.make +
        ", " +
        data.model +
        ", " +
        data.price +
        ", " +
        data.field5 +
        ")",
    );
  }, []);

  const onBtStopEditing = useCallback(() => {
    gridRef.current!.api.stopEditing();
  }, []);

  const onBtStartEditing = useCallback(() => {
    gridRef.current!.api.setFocusedCell(1, "make");
    gridRef.current!.api.startEditingCell({
      rowIndex: 1,
      colKey: "make",
    });
  }, []);

  return (
    <AgGridProvider modules={modules}>
      <div style={containerStyle}>
        <div className="example-wrapper">
          <div style={{ marginBottom: "5px" }}>
            <button style={{ fontSize: "12px" }} onClick={onBtStartEditing}>
              Start Editing Line 2
            </button>
            <button style={{ fontSize: "12px" }} onClick={onBtStopEditing}>
              Stop Editing
            </button>
          </div>
          <div style={gridStyle}>
            <AgGridReact
              ref={gridRef}
              rowData={rowData}
              columnDefs={columnDefs}
              defaultColDef={defaultColDef}
              editType={"fullRow"}
              onCellValueChanged={onCellValueChanged}
              onRowValueChanged={onRowValueChanged}
            />
          </div>
        </div>
      </div>
    </AgGridProvider>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(
  <StrictMode>
    <GridExample />
  </StrictMode>,
);
```

[Live example: Full Row Editing](https://www.ag-grid.com/examples/cell-editing-full-row/full-row-editing/reactFunctionalTs/)


---
title: "Full Row Editing"
framework: angular
version: "36.1.0"
---

# Full Row Editing

Full row editing is for when you want all cells in the row to become editable at the same time. This gives the impression to the user that the record the row represents is being edited.

To enable full row editing, set the grid option `editType = 'fullRow'`.

If using custom cell editors, the cell editors will work in the exact same way with the following additions:

- `focusIn`: If your cell editor has a `focusIn()` method, it will get called when the user tabs into the cell. This should be used to put the focus on the particular item to be focused, e.g. the `textfield` within your cell editor.
- `focusOut`: If your cell editor has a `focusOut()` method, it will get called when the user tabs out of the cell. There is no intended use for this; it's just there to complement the `focusIn()` method.
- Events: When a row stops editing, the `cellValueChanged` event gets called for each column whose value has changed, and `rowValueChanged` gets called once for the row.

### Full Row Edit and Popup Editors

Full row editing is not compatible with popup editors. This is because a) the grid would look confusing to pop up an editor for each cell in the row at the same time and b) the complexity of navigation and popup is almost impossible to model, so the grid and your application code would be messy and very error prone. If you are using full row edit, then you are prevented from using popup editors.

This does not mean that you cannot show a popup from your 'in cell' editor - you are free to do that - however the responsibility of showing and hiding the popup belongs with your editor. You may want to use the grid's focus events to hide the popups when the user tabs or clicks out of the cell.

### Example: Full Row Edit

The example below shows full row editing. In addition to standard full row editing, the following should also be noted:

- The 'Price' column has a custom editor demonstrating how you should implement the `focusIn()` method. Both `focusIn()` and `focusOut()` for this editor are logged to the console. Note that `focusIn()` and `focusOut()` are only called when the user is tabbing between cells when editing, they are not called as the user double clicks on a cell to start editing that cell, or the user finishes editing that cell by e.g. hitting the `↵ Enter` key.
- Pressing `⇥ Tab` / `⇧ Shift` & `⇥ Tab` while editing will move the focus between the cells on the editing row. Read only cells will be focusable while the row is in edit mode.
- The 'Suppress Navigable' column is not navigable using `⇥ Tab` / `⇧ Shift` & `⇥ Tab`. In other words, when tabbing around the grid, you cannot tab onto this cell.
- The **Read Only** column is not editable, so when the row goes into edit mode, the cell in the **Read Only** column cannot be edited.
- The button will start editing line two. It uses the API to start editing a cell, however the result is that the whole row will become editable starting with the specified cell.
- `cellValueChanged` and `rowValueChanged` events are logged to console.

#### Full Row Editing

```ts
import { Component } from "@angular/core";
import { AgGridAngular } from "ag-grid-angular";
import "./styles.css";
import {
  CellValueChangedEvent,
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  CustomEditorModule,
  EditStrategyType,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ModuleRegistry,
  RowValueChangedEvent,
  SelectEditorModule,
  TextEditorModule,
  enableDevValidations,
} from "ag-grid-community";
import {
  ColumnMenuModule,
  ColumnsToolPanelModule,
  ContextMenuModule,
} from "ag-grid-enterprise";
if (process.env.NODE_ENV !== "production") {
  enableDevValidations();
}

ModuleRegistry.registerModules([
  ClientSideRowModelModule,
  ColumnsToolPanelModule,
  ColumnMenuModule,
  ContextMenuModule,
  SelectEditorModule,
  TextEditorModule,
  CustomEditorModule,
]);
import { NumericCellEditor } from "./numeric-cell-editor.component";

@Component({
  selector: "my-app",
  standalone: true,
  imports: [AgGridAngular, NumericCellEditor],
  template: `<div class="example-wrapper">
    <div style="margin-bottom: 5px">
      <button style="font-size: 12px" (click)="onBtStartEditing()">
        Start Editing Line 2
      </button>
      <button style="font-size: 12px" (click)="onBtStopEditing()">
        Stop Editing
      </button>
    </div>
    <ag-grid-angular
      style="width: 100%; height: 100%;"
      [columnDefs]="columnDefs"
      [defaultColDef]="defaultColDef"
      [editType]="editType"
      [rowData]="rowData"
      (cellValueChanged)="onCellValueChanged($event)"
      (rowValueChanged)="onRowValueChanged($event)"
      (gridReady)="onGridReady($event)"
    />
  </div> `,
})
export class AppComponent {
  private gridApi!: GridApi;

  columnDefs: ColDef[] = [
    {
      field: "make",
      cellEditor: "agSelectCellEditor",
      cellEditorParams: {
        values: ["Porsche", "Toyota", "Ford", "AAA", "BBB", "CCC"],
      },
    },
    { field: "model" },
    { field: "field4", headerName: "Read Only", editable: false },
    { field: "price", cellEditor: NumericCellEditor },
    {
      headerName: "Suppress Navigable",
      field: "field5",
      suppressNavigable: true,
      minWidth: 200,
    },
    { headerName: "Read Only", field: "field6", editable: false },
  ];
  defaultColDef: ColDef = {
    flex: 1,
    editable: true,
    cellDataType: false,
  };
  editType: EditStrategyType = "fullRow";
  rowData: any[] | null = getRowData();

  onCellValueChanged(event: CellValueChangedEvent) {
    console.log(
      "onCellValueChanged: " + event.colDef.field + " = " + event.newValue,
    );
  }

  onRowValueChanged(event: RowValueChangedEvent) {
    const data = event.data;
    console.log(
      "onRowValueChanged: (" +
        data.make +
        ", " +
        data.model +
        ", " +
        data.price +
        ", " +
        data.field5 +
        ")",
    );
  }

  onBtStopEditing() {
    this.gridApi.stopEditing();
  }

  onBtStartEditing() {
    this.gridApi.setFocusedCell(1, "make");
    this.gridApi.startEditingCell({
      rowIndex: 1,
      colKey: "make",
    });
  }

  onGridReady(params: GridReadyEvent) {
    this.gridApi = params.api;
  }
}

function getRowData() {
  const rowData = [];
  for (let i = 0; i < 10; i++) {
    rowData.push({
      make: "Toyota",
      model: "Celica",
      price: 35000 + i * 1000,
      field4: "Sample XX",
      field5: "Sample 22",
      field6: "Sample 23",
    });
    rowData.push({
      make: "Ford",
      model: "Mondeo",
      price: 32000 + i * 1000,
      field4: "Sample YY",
      field5: "Sample 24",
      field6: "Sample 25",
    });
    rowData.push({
      make: "Porsche",
      model: "Boxster",
      price: 72000 + i * 1000,
      field4: "Sample ZZ",
      field5: "Sample 26",
      field6: "Sample 27",
    });
  }
  return rowData;
}
```

[Live example: Full Row Editing](https://www.ag-grid.com/examples/cell-editing-full-row/full-row-editing/angular)


---
title: "Full Row Editing"
framework: vue
version: "36.1.0"
---

# Full Row Editing

Full row editing is for when you want all cells in the row to become editable at the same time. This gives the impression to the user that the record the row represents is being edited.

To enable full row editing, set the grid option `editType = 'fullRow'`.

If using custom cell editors, the cell editors will work in the exact same way with the following additions:

- `focusIn`: If your cell editor has a `focusIn()` method, it will get called when the user tabs into the cell. This should be used to put the focus on the particular item to be focused, e.g. the `textfield` within your cell editor.
- `focusOut`: If your cell editor has a `focusOut()` method, it will get called when the user tabs out of the cell. There is no intended use for this; it's just there to complement the `focusIn()` method.
- Events: When a row stops editing, the `cellValueChanged` event gets called for each column whose value has changed, and `rowValueChanged` gets called once for the row.

### Full Row Edit and Popup Editors

Full row editing is not compatible with popup editors. This is because a) the grid would look confusing to pop up an editor for each cell in the row at the same time and b) the complexity of navigation and popup is almost impossible to model, so the grid and your application code would be messy and very error prone. If you are using full row edit, then you are prevented from using popup editors.

This does not mean that you cannot show a popup from your 'in cell' editor - you are free to do that - however the responsibility of showing and hiding the popup belongs with your editor. You may want to use the grid's focus events to hide the popups when the user tabs or clicks out of the cell.

### Example: Full Row Edit

The example below shows full row editing. In addition to standard full row editing, the following should also be noted:

- The 'Price' column has a custom editor demonstrating how you should implement the `focusIn()` method. Both `focusIn()` and `focusOut()` for this editor are logged to the console. Note that `focusIn()` and `focusOut()` are only called when the user is tabbing between cells when editing, they are not called as the user double clicks on a cell to start editing that cell, or the user finishes editing that cell by e.g. hitting the `↵ Enter` key.
- Pressing `⇥ Tab` / `⇧ Shift` & `⇥ Tab` while editing will move the focus between the cells on the editing row. Read only cells will be focusable while the row is in edit mode.
- The 'Suppress Navigable' column is not navigable using `⇥ Tab` / `⇧ Shift` & `⇥ Tab`. In other words, when tabbing around the grid, you cannot tab onto this cell.
- The **Read Only** column is not editable, so when the row goes into edit mode, the cell in the **Read Only** column cannot be edited.
- The button will start editing line two. It uses the API to start editing a cell, however the result is that the whole row will become editable starting with the specified cell.
- `cellValueChanged` and `rowValueChanged` events are logged to console.

#### Full Row Editing

```ts
import {
  createApp,
  defineComponent,
  onBeforeMount,
  ref,
  shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import "./styles.css";
import {
  CellValueChangedEvent,
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  CustomEditorModule,
  EditStrategyType,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ModuleRegistry,
  RowValueChangedEvent,
  SelectEditorModule,
  TextEditorModule,
  enableDevValidations,
} from "ag-grid-community";
import {
  ColumnMenuModule,
  ColumnsToolPanelModule,
  ContextMenuModule,
} from "ag-grid-enterprise";
import NumericCellEditor from "./numericCellEditorVue";
if (process.env.NODE_ENV !== "production") {
  enableDevValidations();
}

ModuleRegistry.registerModules([
  ClientSideRowModelModule,
  ColumnsToolPanelModule,
  ColumnMenuModule,
  ContextMenuModule,
  SelectEditorModule,
  TextEditorModule,
  CustomEditorModule,
]);

function getRowData() {
  const rowData = [];
  for (let i = 0; i < 10; i++) {
    rowData.push({
      make: "Toyota",
      model: "Celica",
      price: 35000 + i * 1000,
      field4: "Sample XX",
      field5: "Sample 22",
      field6: "Sample 23",
    });
    rowData.push({
      make: "Ford",
      model: "Mondeo",
      price: 32000 + i * 1000,
      field4: "Sample YY",
      field5: "Sample 24",
      field6: "Sample 25",
    });
    rowData.push({
      make: "Porsche",
      model: "Boxster",
      price: 72000 + i * 1000,
      field4: "Sample ZZ",
      field5: "Sample 26",
      field6: "Sample 27",
    });
  }
  return rowData;
}

const VueExample = defineComponent({
  template: `
        <div style="height: 100%">
                <div class="example-wrapper">
      <div style="margin-bottom: 5px">
        <button style="font-size: 12px" v-on:click="onBtStartEditing()">Start Editing Line 2</button>
        <button style="font-size: 12px" v-on:click="onBtStopEditing()">Stop Editing</button>
      </div>
      <ag-grid-vue
        style="width: 100%; height: 100%;"
        @grid-ready="onGridReady"
        :columnDefs="columnDefs"
        :defaultColDef="defaultColDef"
        :editType="editType"
        :rowData="rowData"
        @cell-value-changed="onCellValueChanged"
        @row-value-changed="onRowValueChanged"></ag-grid-vue>
      </div>
        </div>
    `,
  components: {
    "ag-grid-vue": AgGridVue,
    NumericCellEditor,
  },
  setup(props) {
    const gridApi = shallowRef<GridApi | null>(null);
    const columnDefs = ref<ColDef[]>([
      {
        field: "make",
        cellEditor: "agSelectCellEditor",
        cellEditorParams: {
          values: ["Porsche", "Toyota", "Ford", "AAA", "BBB", "CCC"],
        },
      },
      { field: "model" },
      { field: "field4", headerName: "Read Only", editable: false },
      { field: "price", cellEditor: "NumericCellEditor" },
      {
        headerName: "Suppress Navigable",
        field: "field5",
        suppressNavigable: true,
        minWidth: 200,
      },
      { headerName: "Read Only", field: "field6", editable: false },
    ]);
    const defaultColDef = ref<ColDef>({
      flex: 1,
      editable: true,
      cellDataType: false,
    });
    const editType = ref<EditStrategyType>("fullRow");
    const rowData = ref<any[] | null>(getRowData());

    function onCellValueChanged(event: CellValueChangedEvent) {
      console.log(
        "onCellValueChanged: " + event.colDef.field + " = " + event.newValue,
      );
    }
    function onRowValueChanged(event: RowValueChangedEvent) {
      const data = event.data;
      console.log(
        "onRowValueChanged: (" +
          data.make +
          ", " +
          data.model +
          ", " +
          data.price +
          ", " +
          data.field5 +
          ")",
      );
    }
    function onBtStopEditing() {
      gridApi.value!.stopEditing();
    }
    function onBtStartEditing() {
      gridApi.value!.setFocusedCell(1, "make");
      gridApi.value!.startEditingCell({
        rowIndex: 1,
        colKey: "make",
      });
    }
    const onGridReady = (params: GridReadyEvent) => {
      gridApi.value = params.api;
    };

    return {
      gridApi,
      columnDefs,
      defaultColDef,
      editType,
      rowData,
      onGridReady,
      onCellValueChanged,
      onRowValueChanged,
      onBtStopEditing,
      onBtStartEditing,
    };
  },
});

const app = createApp(VueExample);
app.mount("#app");
```

[Live example: Full Row Editing](https://www.ag-grid.com/examples/cell-editing-full-row/full-row-editing/vue3)
